var Xport = function()
{
	var xport = {};
	var previewTitle;
	var previewList;
	
	xport.initPage = function()
	{
		previewTitle = Doc.element('previewTitle');
		previewList = Doc.element('previewList');
		
		Buttons.addClickHandler('goexport', xport.goExport);
		Buttons.addClickHandler('gopreview', xport.goPreview);

		Doc.show('step-1');
		Doc.show('gopreview');
		Doc.show('goexport');
	}
	
	xport.goPreview = function()
	{
		xport.doExport(true);
	}
	
	xport.goExport = function()
	{
		xport.doExport(false);
	}
	
	xport.doExport = function(preview)
	{
		var frm = document.forms['reggie'];
		var url = '../Export.servlet?ID='+App.getSessionId();
		url += '&cmd=ExportINCA';
		url += '&time=' + frm.time.value;
		url += '&exportSubtype=1';
		url += '&exportPatientId=1';
		
		if (preview) 
		{
			Doc.hide('previewWrapper');
			url += '&preview=1';
			
			Wizard.showLoadingAnimation('Working...');
			Doc.hide('navigation');
			Wizard.asyncJsonRequest(url, xport.onPreviewLoaded);

		}
		else
		{
			window.location = url;		
		}
	}

	xport.onPreviewLoaded = function(response)
	{
		Doc.show('navigation');
		var frm = document.forms['reggie'];
		var allLines = response.split('\n');
		var numCases = allLines.length - 2; // First line is a header line
		
		var html = '<tr><th>'+allLines[0].replace(/\t/g, '</th><th>')+'</th></tr>';
		// Check last column for the 'Consent' value. All should be 'YES' for the export to be ok.
		var numNoConsent = 0;
		var numMissingConsent = 0;
		for (var i = 1 ; i <= numCases; i++)
		{
			var line = allLines[i];
			var cols = line.split(/\t/);
			var consent = cols[cols.length-1];
			var rowClass = '';
			if (consent != 'YES')
			{
				rowClass = 'consent-warning';
				if (consent == 'MISSING')
				{
					numMissingConsent++;
				}
				else
				{
					numNoConsent++;
				}
			}
			html += '<tr class="'+rowClass+'"><td>'+cols.join('</td><td>')+'</td></tr>';
		}

		var previewWarning = Doc.element('previewWarning');
		if (numMissingConsent > 0 || numNoConsent > 0)
		{
			var warning = '<img src="../images/warning.png" alt="!">';
			warning += ' Found ' + (numNoConsent+numMissingConsent) + ' case(s) with denied or missing consent!';
			previewWarning.innerHTML = warning;
		}
		else
		{
			previewWarning.innerHTML = '';
		}
		
		previewTitle.innerHTML = 'Sample dates - ' + frm.time[frm.time.selectedIndex].text + ' (' + numCases + ')';
		previewList.innerHTML = '<table>'+html+'</table>';
		Doc.show('previewWrapper');
	}

	return xport;
}();

Doc.onLoad(Xport.initPage);

