var RetractionProtocol = function()
{
	var rp = {};
	var debug = 0;
	
	var COLORS = ['blue', 'green', 'yellow', 'red'];
	var nextColor = 0;

	// Page initialization
	rp.initPage = function()
	{
		Buttons.addClickHandler('print-button', Wizard.goPrint);
		var caseName = Data.get('page-data', 'casename');
		var url = '../RetractionForm.servlet?ID='+App.getSessionId();
		url += '&cmd=GetProtocolInfo';
		url += '&caseName=' + encodeURIComponent(caseName);
		Wizard.showLoadingAnimation('Creating protocol...');
		Wizard.asyncJsonRequest(url, rp.initializeProtocol);
	}

	rp.initializeProtocol = function(response)
	{
		var frm = document.forms['reggie'];

		var numCases = response.numCases;
		var patientInfo = response.patient;
		var caseInfo = response.caseInfo;
		var specimenInfo = response.specimen;
		var lysateInfo = response.lysate;
		var rnaInfo = response.rna;
		var dnaInfo = response.dna;
		var ftInfo = response.flowThrough;

		// Patient info
		var patientName = patientInfo.name;
		var patientRow = Doc.element('patient');
		var td = document.createElement('td');
		//td.className = 'patient-legend ' + color;
		td.className = 'patient-legend';
		td.innerHTML = patientName;
		patientRow.appendChild(td);
		//alert("retraction_protocol.js rp.initializeProtocol(): patientName = " + patientName);

		// Cases info
		var caseArray = [];
		var allCasesStr = '-';
		if (numCases > 0)
		{
			caseArray.push(response.caseName1);
			allCasesStr = response.caseName1;
		}
		if (numCases > 1)
		{
			caseArray.push(response.caseName2);
			allCasesStr += ', ' + response.caseName2;
		}
		var allCasesRow = Doc.element('allcases');
		var td2 = document.createElement('td');
		//td.className = 'allcases-legend ' + color;
		td2.className = 'allcases-legend';
		td2.innerHTML = allCasesStr;
		allCasesRow.appendChild(td2);

		// Item data
		var accumItemNo = 0;
		accumItemNo = tableRowsForItems(accumItemNo, specimenInfo, 'Specimen', 'specimen');
		accumItemNo = tableRowsForItems(accumItemNo, lysateInfo, 'Lysate', 'lysate');
		accumItemNo = tableRowsForItems(accumItemNo, rnaInfo, 'RNA', 'rna');
		accumItemNo = tableRowsForItems(accumItemNo, dnaInfo, 'DNA', 'dna');
		accumItemNo = tableRowsForItems(accumItemNo, ftInfo, 'FlowThrough', 'flowthrough');

		Doc.show('all-protocol');
	}
	
	function tableRowsForItems(
		accumItemNo,
		itemJsonArr,
		itemType,
		itemTypeVarName)
	{
		// Table item row
		var html = '';
		if (itemJsonArr && itemJsonArr.length > 0)
		{
			for (var i = 0; i < itemJsonArr.length; i++)
			{
				var item = itemJsonArr[i];
				var storageId = '-';
				var storagePosition = '-';
				if (item)
				{
					storageId = rp.asBioPlateName(item.bioWell);
					storagePosition = rp.asPureBioPlateLocation(item.bioWell);
				}
				// Create HTML code for table column with checkbox for marking destroyed items
				var destroyedCheckboxHtml = '<td><b><div class=\"colorbox\"></div>Destroyed </b></td>';
				// Insert item data in table columns
				Doc.element('itemType.'+accumItemNo).innerHTML = Strings.encodeTags(itemType);
				Doc.element('itemName.'+accumItemNo).innerHTML = Strings.encodeTags(item.name);
				Doc.element('storageId.'+accumItemNo).innerHTML = Strings.encodeTags(storageId);
				Doc.element('storagePosition.'+accumItemNo).innerHTML = Strings.encodeTags(storagePosition);
				//Doc.element('result.'+accumItemNo).innerHTML = Strings.encodeTags('Destroyed');
				Doc.element('result.'+accumItemNo).innerHTML = destroyedCheckboxHtml;
				
				// Increment accumulated item number
				accumItemNo++;
			}
		}
		return accumItemNo;
	}

	// A biowell as plate name
	rp.asBioPlateName = function(well)
	{
		if (!well) return '';
		var plate = well.bioPlate;
		if (!plate) return '';
		var text = plate.name;
		return text;
	}

	// A biowell as the location
	rp.asPureBioPlateLocation = function(well)
	{
		if (!well) return '';
		var plate = well.bioPlate;
		var text = well.location;
		if (plate.storage)
		{
			var storage = plate.storage;
			var tmp = [];
			if (storage.name) tmp[tmp.length] = storage.name;
			if (storage.section) tmp[tmp.length] = 'section: ' +storage.section;
			if (storage.tray) tmp[tmp.length] = 'tray: ' +storage.tray;
			if (storage.position) tmp[tmp.length] = 'position: ' +storage.position;
			text = text + ' ' + tmp.join('; ');
		}
		return text;
	}

	return rp;
}();

Doc.onLoad(RetractionProtocol.initPage);

